-- Switchboard 2.3.3 by JuiCe

local HealthNag = 0;
local InCombat = 0;
local Vol = GetCVar("Sound_MusicVolume");
local XRNag = 0;
local Mounted = 0;
local MountMusic = 0;
local FlightPathMusic = 0;
local EventDefaults = {
	["LowHealth"] = { "Am Low on Health", "Low_Health.mp3" },
	["Camp"] = { "Camp", "Quit.wav" },
	["SpellCrit"] = { "Crit with a Spell", "Critical_Spell.wav" },
	["MeleeCrit"] = { "Crit with Melee", "Critical_Melee.wav" },
	["HealCrit"] = { "Crit with a Heal", "Critical_Heal.wav" },
	["Death"] = { "Die", "Die.wav" },
	["EnterCombat"] = { "Enter Combat", "Enter_Combat.wav" },
	["XP"] = { "Gain Experience", "XP.wav" },
	["Honor"] = { "Gain Honor", "Honor.wav" },
	["LeaveCombat"] = { "Leave Combat", "" },
	["Mount"] = { "Mount", "Mount.mp3" },
	["Whisper"] = { "Receive a Whisper", "Whisper.wav" },
	["FlightPath"] = { "Ride a Flight Path", "" },
	["Auction"] = { "Sell an Item", "AuctionWindowOpen" },
	["Skillup"] = { "Skill up", "Skillup.wav" },
	["WinBattle"] = { "Win a Close Battle", "Win_Battle.wav" },
	["FriendOnline"] = { "See a Friend Come Online", "" },
	["FriendOffline"] = { "See a Friend Go Offline", "" },
	["Login"] = {"Login", ""}
}

function Switchboard_OnLoad(self)
	self:RegisterEvent("CHAT_MSG_SYSTEM");
	self:RegisterEvent("CHAT_MSG_WHISPER");
	self:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
	self:RegisterEvent("CHAT_MSG_CHANNEL");
	self:RegisterEvent("CHAT_MSG_SKILL");
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:RegisterEvent("PLAYER_QUITING");
	self:RegisterEvent("PLAYER_CAMPING");
	self:RegisterEvent("PLAYER_XP_UPDATE");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
	self:RegisterEvent("PET_LOYALTY_GAIN");
	self:RegisterEvent("PET_LOYALTY_LOSS");
	self:RegisterEvent("UNIT_HEALTH");
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	self:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH");
	self:RegisterEvent("PLAYER_LOGIN");
	local SBFrame = CreateFrame("Frame");
	SBFrame:SetScript("OnUpdate",CheckMount);
	
	SLASH_SWITCHBOARD1 = "/switchboard";
	SLASH_SWITCHBOARD2 = "/switchb";
	SLASH_SWITCHBOARD3 = "/sbd";
	SlashCmdList["SWITCHBOARD"] = function()
		SwitchFrame:Show()
	end;
	SLASH_PLAY1 = "/sbplay";
	SLASH_PLAY2 = "/sbsnd";
	SlashCmdList["PLAY"] = Play_Command;
	SLASH_STOP1 = "/sbstop";
	SLASH_STOP2 = "/sbend";
	SlashCmdList["STOP"] = Stop_Command;
	--SLASH_XR1 = "/xralert"
	--SlashCmdList["XR"] = XR_Command;
	
	if (Events == nil) then
		Events = EventDefaults;
	else
		for c=1, Scalar(EventDefaults) do
			local item = GetEventType(EventDefaults,c);
			local data = GetEvent(EventDefaults,c);
			if (Events[item] == nil) then
				Events[item] = data;
			else
				Events[item][1] = data[1];
			end
		end
	end

	local initOptions = function()
		local option = UIDropDownMenu_CreateInfo();
		for c=1, Scalar(EventDefaults) do
			local item = GetEvent(Events,c);
			local event = GetEventType(Events,c);
			if (item ~= nil) then
				option = {};
				option.text = item[1];
				option.arg1 = event;
				option.func = function()
					UIDropDownMenu_SetSelectedID(SwitchFrameEventOptions, self:GetID(), 0);
					SwitchFrameEventOptions.value = self.arg1;
					local sound = Events[self.arg1][2];
					if (sound == nil) then
						sound = "";
					end
					SwitchFrameEditSound:SetText(sound);
					if (sound ~= nil) then
						SwitchFrameEditSound:HighlightText();
						SwitchFrameEditSound:SetFocus();
					end
					SwitchFramePreviewButton:SetText("Play");
				end
				UIDropDownMenu_AddButton(option);
			end
		end
	end
	UIDropDownMenu_Initialize(SwitchFrameEventOptions, initOptions);
	SwitchFrameEditSound:SetAutoFocus(false);
end

function Scalar(Table)
local items = 0;
	for key, value in pairs(Table) do
		items = items + 1;
	end
	return items;
end

function GetEvent(EventList, index)
if (EventList == nil) then return end;
local item = 0;
	for key, value in pairs(EventList) do
		item = item + 1;
		if (item == index) then
			return value;
		end
	end
end

function GetEventType(EventList, index)
if (EventList == nil) then return end;
local item = 0;
	for key, value in pairs(EventList) do
		item = item + 1;
		if (item == index) then
			return key;
		end
	end
end

function Play(target,loop)
if (target == nil or target[2] == nil) then return end
local path = "Interface\\Addons\\Switchboard\\Sound\\";
local sound = target[2];
local ext = strlower(strsub(target[2],strlen(target[2])-3));
local ret;
	if (ext == ".mp3") then
		if (loop == true) then
			PlayMusic(path..sound);
			return true;
		else
			if (strfind(sound,"\\") ~= nil) then
				sound = gsub(sound,"(\\+)","\\");
				PlaySoundFile(sound);
			else
				PlayMusic(path..sound);
				return true;
			end
		end
	elseif (ext == ".wav") then
		if (strfind(sound,"\\") ~= nil) then
			sound = gsub(sound,"(\\+)","\\");
			PlaySoundFile(sound);
		else
			PlaySoundFile(path..sound);
		end
	else
		ret = PlaySound(sound);
		if (ret == nil) then
			ret = PlaySoundFile(path..sound..".wav");
			if (ret == nil) then
				PlaySoundFile(path..sound..".mp3");
			end
		end
	end
end

function Play_Command(cmd)
	Play({nil, cmd});
end

function Push(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg,1,1,0);
end

function Stop_Command()
	SetCVar("Sound_MusicVolume",Vol);
	StopMusic();
end

function XR_Command(cmd)
	if (cmd == "on") then
		XRNag = 1;
		Push("The battle horn will sound.");
	elseif (cmd == "off") then
		XRNag = 0;
		Push("The battle horn will no longer sound.");
	end
end

function CheckMount()
	if (IsMounted() == 1) then
		if (Mounted ~= 1) then
			Mounted = 1;
			if (UnitOnTaxi("player") ~= 1) then
				local sound = Events["Mount"][2];
				if (sound ~= nil and strlen(sound)>4) then
					if (strfind(strlower(sound),".mp3") ~= nil) then
						MountMusic = 1;
						SetCVar("Sound_MusicVolume",1);
					end
					Play(Events["Mount"],true);
				end
			else
				local sound = Events["FlightPath"][2];
				if (sound ~= nil and strlen(sound)>4) then
					if (strfind(strlower(sound),".mp3") ~= nil) then
						FlightPathMusic = 1;
						SetCVar("Sound_MusicVolume",1);
					end
					Play(Events["FlightPath"],true);
				end
			end
		end
	else
		if (Mounted == 1) then
			if (MountMusic == 1 or FlightPathMusic == 1) then
				MountMusic = 0;
				FlightPathMusic = 0;
				StopMusic();
				SetCVar("Sound_MusicVolume",Vol);
			end
		end
		Mounted = 0;
	end
end

function Switchboard_Chat(data,player)
	if (player ~= nil) then
		if (data == format(ERR_FRIEND_ONLINE_SS, player, player)) then
			Play(Events["FriendOnline"]);
		end
	else
		if (strfind(data," ") ~= nil) then
			player = strsub(data,1,strfind(data," ")-1);
			if (player ~= nil) then
				if (data == format(ERR_FRIEND_OFFLINE_S, player)) then
					Play(Events["FriendOffline"]);
				end
			end
		end
	end
end

function Switchboard_OnEvent(event,param1,param2,param3,param4,param5)
	if (event == "ADDON_LOADED" and param1 == "Switchboard") then
		Switchboard_OnLoad();
	elseif (event == "CHAT_MSG_WHISPER") then
		Play(Events["Whisper"]);
	elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (arg4 == UnitName("player")) then
			if (param2 == "SPELL_DAMAGE" and arg18 == 1) then
				Play(Events["SpellCrit"]);
			elseif (param2 == "SWING_DAMAGE" and arg15 == 1) then
				Play(Events["MeleeCrit"]);
			elseif (param2 == "SPELL_HEAL" and arg15 == 1) then
				Play(Events["HealCrit"]);
			end
		end
	elseif (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
		Play(Events["Honor"]);		
	elseif (event == "CHAT_MSG_CHANNEL") then
		--if (strfind(param1, "The Crossroads is under attack!") ~= nil and XRNag == 1) then
			--Play(Events["Battle_Horn"]);
		--end
	elseif (event == "CHAT_MSG_SKILL") then
		Play(Events["Skillup"]);
	elseif (event == "CHAT_MSG_SYSTEM") then
		local _, _, player = strfind(arg1, "|Hplayer:(.+)|h%[(.+)%]|h");
		if (strfind(param1, "A buyer has been found for your auction of (.+)") ~= nil) then
			Play(Events["Auction"]);
		else
			Switchboard_Chat(arg1,player);
		end
	elseif (event == "PLAYER_QUITING" or event == "PLAYER_CAMPING") then
		Play(Events["Camp"]);
	elseif (event == "PLAYER_XP_UPDATE") then
		Play(Events["XP"]);
	elseif (event == "PLAYER_REGEN_DISABLED") then
		InCombat = 1;
		Play(Events["EnterCombat"]);
	elseif (event == "UNIT_HEALTH") then
		if (param1 == "player") then
			local MaxHP = UnitHealthMax("player");
			local HP = UnitHealth("player");
			local Pct = floor((HP / MaxHP) * 100);
			local sound = Events["LowHealth"][2];
			if (Pct <= 25 and InCombat == 1) then
				if (HealthNag == 0) then
					HealthNag = 1;
					if (sound ~= nil and strfind(strlower(sound),".mp3") ~= nil) then
						SetCVar("Sound_MusicVolume",1);
					end
					Play(Events["LowHealth"],true);
				end
			elseif (Pct > 25 and InCombat == 1) then
				if (HealthNag == 1) then
					HealthNag = 0;
					if (sound ~= nil and strfind(strlower(sound),".mp3") ~= nil) then
						StopMusic();
						SetCVar("Sound_MusicVolume",Vol);
					end
				end
			end
		end
	elseif (event == "PLAYER_REGEN_ENABLED") then
		InCombat = 0;
		local HP = UnitHealth("player");
		if (HealthNag == 1) then
			HealthNag = 0;
			if (Events["LowHealth"][2] ~= nil and strfind(strlower(Events["LowHealth"][2]),".mp3") ~= nil) then
				StopMusic();
				SetCVar("Sound_MusicVolume",Vol);
			end
			if (HP > 0) then
				if (Events["WinBattle"][2] ~= nil) then
					Play(Events["WinBattle"]);
				else
					Play(Events["LeaveCombat"]);
				end
			else
				Play(Events["Die"]);
			end
		else
			Play(Events["LeaveCombat"]);
		end
	elseif (event == "PET_LOYALTY_GAIN") then
		-- Haven't tested this yet
		-- DEFAULT_CHAT_FRAME:AddMessage("Your pet has become more loyal.");
	elseif (event == "PET_LOYALTY_LOSS") then
		-- Haven't tested this yet
		-- DEFAULT_CHAT_FRAME:AddMessage("Your pet has become less loyal.");
	elseif (event == "CHAT_MSG_COMBAT_FRIENDLY_DEATH") then
		if (param1 == "You die.") then
			InCombat = 0;
			Play(Events["Die"]);
			if (HealthNag == 1) then
				HealthNag = 0;
				StopMusic();
				SetCVar("Sound_MusicVolume",Vol);
			end
		end
	elseif (event == "PLAYER_LOGIN") then
		Play(Events["Login"]);
	end
end
